<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER.tsx.ftl
</#ibizinclude>

    getDatas(): any[] {
        return [];
    }

    getData(): any {
        return;
    }

    /**
     * 视图状态订阅对象
     *
     * @private
     * @type {Subject<{action: string, data: any}>}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private wizardState: Subject<ViewState> = new Subject();

    /**
     * 当前激活表单
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    <#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getFirstPSDEWizardForm()??>
    <#assign firstForm = ctrl.getPSDEWizard().getFirstPSDEWizardForm()>
    public activeForm: string = '${ctrl.name}_form_${firstForm.getFormTag()}';
    <#else>
    public activeForm: string = '';
    </#if>

    /**
     * 传入url值
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private url: string = '<#ibizinclude>../@MACRO/CONTROL/URL.tsx.ftl</#ibizinclude>';

    /**
     * 向导表单参数
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public formParam: any = {};

    /**
     * 执行过的表单
     *
     * @private
     * @type {Array<string>}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public historyForms: Array<string> = [];

    /**
     * 步骤行为集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public stepActions: any = {};

    /**
     * 向导表单集合
     *
     * @type {Array<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public wizardForms: Array<any> = [];

    /**
     * 当前状态
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public curState = '';

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public created(): void {
        this.regFormActions();
        if(this.activeForm) {
            this.historyForms.push(this.activeForm);
        }
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (Object.is(tag, this.name)) {
                    if (Object.is('load', action)) {
                        this.initAction(data);
                    }
                }
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public destroyed() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 注册表单步骤行为
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public regFormActions() {
        <#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getPSDEWizardForms()??>
        <#list ctrl.getPSDEWizard().getPSDEWizardForms() as form>
        this.regFormAction('${ctrl.name}_form_${form.getFormTag()}', [<#if form.getStepActions()??><#list form.getStepActions() as action><#if action_index gt 0>,</#if>'${action}'</#list></#if>]);
        </#list>
        </#if>
    }

    /**
     * 注册表单步骤行为
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public regFormAction(name: string, actions: Array<string>) {
        this.stepActions[name] = actions;
        this.wizardForms.push(name);
    }

    /**
     * 初始化行为
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public initAction(opt: any = {}) {
        <#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getInitPSDEAction()??>
        <#assign action = ctrl.getPSDEWizard().getInitPSDEAction()>
        const arg: any = { ...opt };
        const post: Promise<any> = this.$http.post(this.url + '${action.getCodeName()?lower_case}', arg);
        post.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.formParam = { srfkey: data.srfkey };
                this.formLoad();
            }
        }).catch((response: any) => {
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: '错误', desc: response.info });
        });
        </#if>
    }

    /**
     * 表单加载
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public formLoad() {
        if(this.activeForm) {
            this.wizardState.next({ tag: this.activeForm, action: 'load', data: this.formParam });
        }
    }

    /**
     * 完成行为
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public finishAction() {
        <#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getFinishPSDEAction()??>
        <#assign action = ctrl.getPSDEWizard().getFinishPSDEAction()>
        let arg: any = {};
        Object.assign(arg, this.formParam);
        const post: Promise<any> = this.$http.post(this.url + '${action.getCodeName()?lower_case}', arg);
        post.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.$emit("finish", data);
            }
        }).catch((response: any) => {
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: '错误', desc: response.info });
        });
        </#if>
    }

    /**
     * 向导表单加载完成
     *
     * @param {*} args
     * @param {string} name
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public ${ctrl.name}_formload(args: any, name: string, $event2?: any) {
        if(args) {
            Object.assign(this.formParam, args);
        }
    }

    /**
     * 向导表单保存完成
     *
     * @param {*} args
     * @param {string} name
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public ${ctrl.name}_formsave(args: any, name: string, $event2?: any) {
        Object.assign(this.formParam, args);
        if(Object.is(this.curState, 'NEXT')) {
            this.historyForms.push(name);
            if(args.srfnextform) {
                this.activeForm = '${ctrl.name}_form_' + args.srfnextform;
                setTimeout(() => {
                    this.formLoad();
                }, 1);
            } else if (this.getNextForm()) {
                this.activeForm = this.getNextForm();
                setTimeout(() => {
                    this.formLoad();
                }, 1);
            } else {
                this.finishAction();
            }
        }
        if(Object.is(this.curState, 'FINISH')) {
            this.finishAction();
        }
    }

    /**
     * 获取下一步向导表单
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getNextForm() {
        let index = this.wizardForms.indexOf(this.activeForm);
        if(index >= 0) {
            if(this.wizardForms[index + 1]) {
                return this.wizardForms[index + 1];
            }
        }
        return undefined;
    }


    /**
     * 上一步
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onClickPrev() {
        const length = this.historyForms.length;
        if(length > 1) {
            this.curState = 'PREV';
            this.activeForm = this.historyForms[length - 1];
            setTimeout(() => {
                this.formLoad();
            }, 1);
            this.historyForms.splice(length - 1, 1);
        }
    }

    /**
     * 下一步
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onClickNext() {
        if(this.activeForm) {
            if(this.$refs && this.$refs[this.activeForm]){
                let form: any = this.$refs[this.activeForm];
                if(form.formValidateStatus()) {
                    this.curState = 'NEXT';
                    this.wizardState.next({ tag: this.activeForm, action: 'save', data: this.formParam });
                } else {
                    this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                }
            }
        }
    }

    /**
     * 完成
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onClickFinish() {
        if(this.activeForm) {
            if(this.$refs && this.$refs[this.activeForm]){
                let form: any = this.$refs[this.activeForm];
                if(form.formValidateStatus()) {
                    this.curState = 'FINISH';
                    this.wizardState.next({ tag: this.activeForm, action: 'save', data: this.formParam });
                } else {
                    this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                }
            }
        }
    }

    /**
     * 是否启用
     *
     * @param {string} type
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public isDisabled(type: string) {
        const actions: Array<string> = this.stepActions[this.activeForm]
        if(actions && actions.indexOf(type) < 0) {
            return true;
        }
        return false;
    }

    /**
     * 绘制内容
     *
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public render() {
        return (
        <layout class="app-wizard">
            <i-content class="app-wizard-content">
                {this.renderForm()}
            </i-content>
            <footer class="app-wizard-footer">
                <i-button disabled={this.isDisabled('PREV')} on-click={() => this.onClickPrev()} type="primary">上一步</i-button>
                <i-button disabled={this.isDisabled('NEXT')} on-click={() => this.onClickNext()} type="primary">下一步</i-button>
                <i-button disabled={this.isDisabled('FINISH')} on-click={() => this.onClickFinish()} type="primary">完成</i-button>
            </footer>
        </layout>
        );
    }

    /**
     * 绘制表单
     *
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public renderForm() {
        let content;
        switch(this.activeForm) {
<#if ctrl.getPSDEEditForms()??>
<#list ctrl.getPSDEEditForms() as form>
<#assign handler = form.getPSAjaxControlHandler() />
<#assign content>
 <#if handler.getPSAjaxHandlerActions()??><#list handler.getPSAjaxHandlerActions() as action><#if action.getPSDEAction()??>  ${action.name?lower_case}Action="${action.getPSDEAction().getCodeName()?lower_case}"</#if></#list></#if></#assign>
            case '${form.name}':
                content = (<view_${form.getName()} key='${form.name}' viewState={this.wizardState}<#if content??>${content}</#if> name='${form.name}' ref='${form.name}' <#if form.getHookEventNames()??><#list form.getHookEventNames() as eventName>on-${eventName?lower_case}={($event: any) => this.${form.name}_${eventName?lower_case}($event)} </#list></#if>></view_${form.getName()}>);
                break;
            
</#list>
</#if>
        }
        return content;
    }

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM.tsx.ftl
</#ibizinclude>